package se.softstuff.nb.translate;

import se.softstuff.nb.guicomponentmarker.StatStopTracerEventListener;
import se.softstuff.nb.domain.tracer.TracerManager;
import java.awt.AWTEvent;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.IOException;
import java.util.List;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import org.apache.log4j.Logger;
import org.netbeans.core.spi.multiview.CloseOperationState;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.netbeans.core.spi.multiview.MultiViewElementCallback;
import org.netbeans.core.spi.multiview.MultiViewFactory;
import org.openide.awt.UndoRedo;
import org.openide.cookies.SaveCookie;
import org.openide.util.Exceptions;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;
import org.openide.util.NbBundle.Messages;
import org.openide.windows.TopComponent;

@MultiViewElement.Registration(displayName = "#LBL_SoftNbTranslate_VISUAL",
iconBase = "se/softstuff/nb/translate/nb_translate.png",
mimeType = "application/soft_translate+xml",
persistenceType = TopComponent.PERSISTENCE_NEVER,
preferredID = "SoftNbTranslateVisual",
position = 2000)
@Messages("LBL_SoftNbTranslate_VISUAL=Visual")
public final class SoftNbTranslateVisualElement extends JPanel implements MultiViewElement {

    private final Logger log;
    private final SoftNbTranslateDataObject data;
    private final SoftNbTranslate sot;
    private MyFilterListModel filterListModel;
    private JToolBar toolbar = new JToolBar();
    private transient MultiViewElementCallback callback;
    private boolean isChanged;
    private SoftNbTranslateManager manager;
    private SotChanges sotChanges;
    private StartToggleAction toggler;

    public SoftNbTranslateVisualElement(Lookup lkp) {
        data = lkp.lookup(SoftNbTranslateDataObject.class);
        assert data != null;
        log = Logger.getLogger(getClass());
        sot = data.getContent();
        sotChanges = new SotChanges();
        sot.addPropertyChangeListener(sotChanges);
        filterListModel = new MyFilterListModel(sot.getResourceFilter());
        isChanged = false;

        SoftNbTranslateManager.exit();
        manager = SoftNbTranslateManager.create(data);

        toggler = new StartToggleAction();
//        KeyStroke hotKey = KeyStroke.getKeyStroke(KeyEvent.VK_T, KeyEvent.CTRL_DOWN_MASK);
//        StartStopKeyEventDispatcher.getInstance().addAction(hotKey, toggler);

        initComponents();

        updateRunningStatus();

        initFilters();

    }

    private CloseOperationState createSaveOnCloseDialog() {
        if (!isChanged) {
            return CloseOperationState.STATE_OK;
        }

        Action closeDialog = new CloseSaveConfirmAction();

        String msg = NbBundle.getMessage(SoftNbTranslateVisualElement.class, "SoftNbTranslateVisualElement.save.confirm.dialog", data.getName());

        return MultiViewFactory.createUnsafeCloseState(msg, closeDialog, MultiViewFactory.NOOP_CLOSE_ACTION);

    }

    private void initFilters() {
        filterList.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

            @Override
            public void valueChanged(ListSelectionEvent e) {
                filterRemoveButton.setEnabled(e.getFirstIndex() != -1);
            }
        });
    }

    @Override
    public String getName() {
        return "SoftNbTranslateVisualElement";
    }

    public SoftNbTranslate getSot() {
        return sot;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        versionLabel = new javax.swing.JLabel();
        versionTextField = new javax.swing.JTextField();
        filterLabel = new javax.swing.JLabel();
        filterTextField = new javax.swing.JTextField();
        filterAddButton = new javax.swing.JButton();
        filterRemoveButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        filterList = new javax.swing.JList();
        controlPanel = new javax.swing.JPanel();
        statusLabel = new javax.swing.JLabel();
        startButton = new javax.swing.JButton();

        setName("Form"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(versionLabel, NbBundle.getMessage(SoftNbTranslateVisualElement.class, "SoftNbTranslateVisualElement.versionLabel.text")); // NOI18N
        versionLabel.setName("versionLabel"); // NOI18N

        versionTextField.setEditable(false);
        versionTextField.setName("versionTextField"); // NOI18N

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, this, org.jdesktop.beansbinding.ELProperty.create("${sot.version}"), versionTextField, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        org.openide.awt.Mnemonics.setLocalizedText(filterLabel, NbBundle.getMessage(SoftNbTranslateVisualElement.class, "SoftNbTranslateVisualElement.filterLabel.text")); // NOI18N
        filterLabel.setName("filterLabel"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(filterAddButton, NbBundle.getMessage(SoftNbTranslateVisualElement.class, "SoftNbTranslateVisualElement.filterAddButton.text")); // NOI18N
        filterAddButton.setName("filterAddButton"); // NOI18N
        filterAddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filterAddButtonActionPerformed(evt);
            }
        });

        org.openide.awt.Mnemonics.setLocalizedText(filterRemoveButton, NbBundle.getMessage(SoftNbTranslateVisualElement.class, "SoftNbTranslateVisualElement.filterRemoveButton.text")); // NOI18N
        filterRemoveButton.setName("filterRemoveButton"); // NOI18N
        filterRemoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filterRemoveButtonActionPerformed(evt);
            }
        });

        filterList.setModel(filterListModel);
        jScrollPane1.setViewportView(filterList);

        org.openide.awt.Mnemonics.setLocalizedText(statusLabel, NbBundle.getMessage(SoftNbTranslateVisualElement.class, "SoftNbTranslateVisualElement.statusLabel.text", manager.isRunning()?"not ":"")); // NOI18N
        statusLabel.setName("statusLabel"); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(startButton, NbBundle.getMessage(SoftNbTranslateVisualElement.class, "SoftNbTranslateVisualElement.startButton.text")); // NOI18N
        startButton.setName("startButton"); // NOI18N
        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout controlPanelLayout = new javax.swing.GroupLayout(controlPanel);
        controlPanel.setLayout(controlPanelLayout);
        controlPanelLayout.setHorizontalGroup(
            controlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(controlPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(statusLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 168, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(startButton)
                .addContainerGap(106, Short.MAX_VALUE))
        );
        controlPanelLayout.setVerticalGroup(
            controlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(controlPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(controlPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(statusLabel)
                    .addComponent(startButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 331, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(filterLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE)
                            .addComponent(filterTextField)
                            .addComponent(versionLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(filterAddButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(filterRemoveButton))
                            .addComponent(versionTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(46, 46, 46)
                .addComponent(controlPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(29, 29, 29))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(controlPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(versionLabel)
                            .addComponent(versionTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(filterLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(filterAddButton)
                                .addComponent(filterRemoveButton))
                            .addComponent(filterTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 147, Short.MAX_VALUE)))
                .addContainerGap())
        );

        bindingGroup.bind();
    }// </editor-fold>//GEN-END:initComponents

    private void filterAddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filterAddButtonActionPerformed
        String newFilter = filterTextField.getText();
        filterTextField.setText("");
        sot.addResourceFilter(newFilter);
        data.setModified(true);
    }//GEN-LAST:event_filterAddButtonActionPerformed

    private void filterRemoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filterRemoveButtonActionPerformed
        String selectedFilter = (String) filterList.getSelectedValue();
        sot.removeResourceFilter(selectedFilter);
        data.setModified(true);
    }//GEN-LAST:event_filterRemoveButtonActionPerformed

    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
        startToggel();
    }

    private void startToggel() {
        if (manager.isRunning()) {
            manager.stop();
        } else {
            manager.start();
        }
        updateRunningStatus();
    }//GEN-LAST:event_startButtonActionPerformed

    private void updateRunningStatus() {

        String startButtonKey = "SoftNbTranslateVisualElement.startButton." + (manager.isRunning() ? "stop.text" : "text");
        String startButtonTitle = NbBundle.getMessage(SoftNbTranslateVisualElement.class, startButtonKey);
        String statusLabelTitle = NbBundle.getMessage(SoftNbTranslateVisualElement.class, "SoftNbTranslateVisualElement.statusLabel.text", manager.isRunning() ? "" : "not ");
        startButton.setText(startButtonTitle);
        statusLabel.setText(statusLabelTitle);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel controlPanel;
    private javax.swing.JButton filterAddButton;
    private javax.swing.JLabel filterLabel;
    private javax.swing.JList filterList;
    private javax.swing.JButton filterRemoveButton;
    private javax.swing.JTextField filterTextField;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JButton startButton;
    private javax.swing.JLabel statusLabel;
    private javax.swing.JLabel versionLabel;
    private javax.swing.JTextField versionTextField;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables

    @Override
    public JComponent getVisualRepresentation() {
        return this;
    }

    @Override
    public JComponent getToolbarRepresentation() {
        return toolbar;
    }

    @Override
    public Action[] getActions() {
        return new Action[]{toggler};
    }

    @Override
    public Lookup getLookup() {
        return data.getLookup();
    }

    @Override
    public void componentOpened() {

//        int toggleMask = MouseEvent.SHIFT_DOWN_MASK | MouseEvent.CTRL_DOWN_MASK | MouseEvent.BUTTON1_DOWN_MASK;
//        int trackerPauseMask = MouseEvent.BUTTON3_DOWN_MASK;
        
//        StatStopTracerEventListener.Trigger toggleTrigger = new StatStopTracerEventListener.Trigger(false, true, true, MouseEvent.BUTTON1);
//        StatStopTracerEventListener.Trigger pauseTrigger = new StatStopTracerEventListener.Trigger(false, false, false, MouseEvent.BUTTON3);
//
//        StatStopTracerEventListener statStopListener = new StatStopTracerEventListener(toggleTrigger, pauseTrigger);
//        Toolkit toolkit = Toolkit.getDefaultToolkit();
////        toolkit.addAWTEventListener(statStopListener, AWTEvent.KEY_EVENT_MASK);
////        toolkit.addAWTEventListener(statStopListener, AWTEvent.MOUSE_MOTION_EVENT_MASK);
//        toolkit.addAWTEventListener(statStopListener, AWTEvent.MOUSE_EVENT_MASK);
//        StartStopKeyEventDispatcher.registerDispatcher();
    }

    @Override
    public void componentClosed() {
//        StartStopKeyEventDispatcher.unregisterDispatcher();
    }

    @Override
    public void componentShowing() {
    }

    @Override
    public void componentHidden() {
    }

    @Override
    public void componentActivated() {
    }

    @Override
    public void componentDeactivated() {
    }

    @Override
    public UndoRedo getUndoRedo() {
        return UndoRedo.NONE;
    }

    @Override
    public void setMultiViewCallback(MultiViewElementCallback callback) {
        this.callback = callback;
    }

    @Override
    public CloseOperationState canCloseElement() {
        CloseOperationState closeController = createSaveOnCloseDialog();

        return closeController;
    }

//    class UnSavedChanges extends CloseOperationState {
//        UnSavedChanges(){
//            super();
//        }
//        
//    };
    class MyFilterListModel extends AbstractListModel {

        final List<String> rows;

        public MyFilterListModel(List<String> rows) {
            this.rows = rows;
        }

        void reload() {
            fireContentsChanged(this, 0, rows.size() - 1);
        }

        @Override
        public int getSize() {
            return rows.size();
        }

        @Override
        public String getElementAt(int index) {
            return rows.get(index);
        }
    }

    class CloseSaveConfirmAction extends AbstractAction {

        @Override
        public void actionPerformed(ActionEvent e) {
            try {
                data.getCookie(SaveCookie.class).save();
            } catch (IOException ex) {
                Exceptions.printStackTrace(ex);
            }
        }
    }

    private class SotChanges implements PropertyChangeListener {

        @Override
        public void propertyChange(PropertyChangeEvent evt) {
            log.debug("sot changed " + evt); //NOI18N
            if (evt.getPropertyName().equals(SoftNbTranslate.PROP_RESOURSE_FILTER)) {
                filterListModel.reload();
            }
            isChanged = true;
        }
    }

    private class StartToggleAction extends AbstractAction {

        @Override
        public void actionPerformed(ActionEvent e) {
            startToggel();
        }
    }
}
